/**
 * generated by Xtext 2.25.0
 */
package org.xtext.example.methodname.methodName;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Kind</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see org.xtext.example.methodname.methodName.MethodNamePackage#getKind()
 * @model
 * @generated
 */
public enum Kind implements Enumerator
{
  /**
   * The '<em><b>KIND INTERFACE</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #KIND_INTERFACE_VALUE
   * @generated
   * @ordered
   */
  KIND_INTERFACE(0, "KIND_INTERFACE", "interface"),

  /**
   * The '<em><b>KIND PACKAGE</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #KIND_PACKAGE_VALUE
   * @generated
   * @ordered
   */
  KIND_PACKAGE(1, "KIND_PACKAGE", "package"),

  /**
   * The '<em><b>KIND CLASS</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #KIND_CLASS_VALUE
   * @generated
   * @ordered
   */
  KIND_CLASS(2, "KIND_CLASS", "class"),

  /**
   * The '<em><b>KIND METHOD</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #KIND_METHOD_VALUE
   * @generated
   * @ordered
   */
  KIND_METHOD(3, "KIND_METHOD", "method"),

  /**
   * The '<em><b>KIND VAR</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #KIND_VAR_VALUE
   * @generated
   * @ordered
   */
  KIND_VAR(4, "KIND_VAR", "variable");

  /**
   * The '<em><b>KIND INTERFACE</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #KIND_INTERFACE
   * @model literal="interface"
   * @generated
   * @ordered
   */
  public static final int KIND_INTERFACE_VALUE = 0;

  /**
   * The '<em><b>KIND PACKAGE</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #KIND_PACKAGE
   * @model literal="package"
   * @generated
   * @ordered
   */
  public static final int KIND_PACKAGE_VALUE = 1;

  /**
   * The '<em><b>KIND CLASS</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #KIND_CLASS
   * @model literal="class"
   * @generated
   * @ordered
   */
  public static final int KIND_CLASS_VALUE = 2;

  /**
   * The '<em><b>KIND METHOD</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #KIND_METHOD
   * @model literal="method"
   * @generated
   * @ordered
   */
  public static final int KIND_METHOD_VALUE = 3;

  /**
   * The '<em><b>KIND VAR</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #KIND_VAR
   * @model literal="variable"
   * @generated
   * @ordered
   */
  public static final int KIND_VAR_VALUE = 4;

  /**
   * An array of all the '<em><b>Kind</b></em>' enumerators.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private static final Kind[] VALUES_ARRAY =
    new Kind[]
    {
      KIND_INTERFACE,
      KIND_PACKAGE,
      KIND_CLASS,
      KIND_METHOD,
      KIND_VAR,
    };

  /**
   * A public read-only list of all the '<em><b>Kind</b></em>' enumerators.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final List<Kind> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

  /**
   * Returns the '<em><b>Kind</b></em>' literal with the specified literal value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param literal the literal.
   * @return the matching enumerator or <code>null</code>.
   * @generated
   */
  public static Kind get(String literal)
  {
    for (int i = 0; i < VALUES_ARRAY.length; ++i)
    {
      Kind result = VALUES_ARRAY[i];
      if (result.toString().equals(literal))
      {
        return result;
      }
    }
    return null;
  }

  /**
   * Returns the '<em><b>Kind</b></em>' literal with the specified name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param name the name.
   * @return the matching enumerator or <code>null</code>.
   * @generated
   */
  public static Kind getByName(String name)
  {
    for (int i = 0; i < VALUES_ARRAY.length; ++i)
    {
      Kind result = VALUES_ARRAY[i];
      if (result.getName().equals(name))
      {
        return result;
      }
    }
    return null;
  }

  /**
   * Returns the '<em><b>Kind</b></em>' literal with the specified integer value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the integer value.
   * @return the matching enumerator or <code>null</code>.
   * @generated
   */
  public static Kind get(int value)
  {
    switch (value)
    {
      case KIND_INTERFACE_VALUE: return KIND_INTERFACE;
      case KIND_PACKAGE_VALUE: return KIND_PACKAGE;
      case KIND_CLASS_VALUE: return KIND_CLASS;
      case KIND_METHOD_VALUE: return KIND_METHOD;
      case KIND_VAR_VALUE: return KIND_VAR;
    }
    return null;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final int value;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final String name;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final String literal;

  /**
   * Only this class can construct instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private Kind(int value, String name, String literal)
  {
    this.value = value;
    this.name = name;
    this.literal = literal;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int getValue()
  {
    return value;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getName()
  {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getLiteral()
  {
    return literal;
  }

  /**
   * Returns the literal value of the enumerator, which is its string representation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    return literal;
  }
  
} //Kind
